= How do I use yasca to perform static source code analysis? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://www.scovetta.com/yasca.html Yasca] (Yet Another Source Code Analyzer) is a source code analysis tool used to scan code written in Java, C/C++, HTML, JavaScript, ASP, ColdFustion, PHP, COBOL, .NET, and other languages. It has the capability to work in conjunction with the following tools:

 * FindBugs
 * PMD
 * JLint
 * JavaScriptLint
 * PHPLint
 * CppCheck
 * ClamAV
 * RATS
 * Pixy


Additionally, its functionality can be easily expanded by writing a custom rule with a regular expression. 

== Usage ==

Yasca is a command line tool, and does not need additional services started prior to usage. To run yasca, change to its current directory, which is /opt/yasca then run the commands:

{{{
  cd /opt/yasca
  ./yasca [options] target_source_directory
}}}

Command line options:
-o [filename]     Designates the output file for the scan results. If no file is defined, YASCA will create a unique file within its directory
-f [filename]     Experimental option which attempts to write fixes to resolve the findings of the scan
-h        Displays help and additional command options

Sample command line prompts for using YASCA

./yasca “source_code_root_directory/*” –o /tmp/Yasca-Reports-${Date}.html “/var/lib/Jenkins/jobs/InsecureApp/workspace/source/”

Note that spaces and invalid characters produce errors in the above command, even when “” are used. This is a php based application and not all special characters are rendered equally

Without sudo or using root privileges, the results will be written to /tmp/ directory as returned in command line output of executing code. Alternative command line execution provides the output file to use


=== More information ===

To run YASCA through Jenkins and send the reports to a unified directory, run the command below as follows:

{{{
  /opt/yasca –o /tmp/output_scans/Yasca-Reports-${Date}.html “/var/lib/Jenkins/jobs/${Target_Application}/workspace/source/”
}}} 

For more extensible features, download 3rd party plugins and place them in /opt/yasca/plugins_3rdParty

These plugins can be called with the command:

{{{
  /opt/yasca –sa_home /opt/yasca/plugins_3rdParty –o /tmp/output_scans/Yasca-Reports-${Date}.html “/var/lib/Jenkins/jobs/InsecureApp/workspace/source/”
}}}